SystemOrganization addCategory: #'Xtreams-ParsingTests'!

TestCase subclass: #PEGParserBootstrapTest
	instanceVariableNames: 'parser result rule'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xtreams-ParsingTests'!

!PEGParserBootstrapTest methodsFor: 'initialize-release' stamp: 'nice 1/14/2011 23:18'!
setUp
	parser := PEGParser parserBootstrap! !

!PEGParserBootstrapTest methodsFor: 'testing' stamp: 'nice 1/14/2011 23:18'!
testParsePEG
	self assert: (parser parse: 'Grammar' stream: PEGParser grammarPEG reading positioning actor: nil) notEmpty.
	self assert: (parser parse: 'Grammar' stream: PEGParser grammarPEG reading positioning actor: PEGParserParser new) grammar size = 52! !

!PEGParserBootstrapTest methodsFor: 'testing' stamp: 'nice 1/14/2011 23:19'!
testParsePEGwithPEG
	parser := parser parse: 'Grammar' stream: PEGParser grammarPEG reading positioning actor: PEGParserParser new.
	self testParsePEG! !

!PEGParserBootstrapTest methodsFor: 'testing' stamp: 'nice 1/14/2011 23:19'!
testValidatePEG
	self assert: (parser validate: 'Grammar' stream: PEGParser grammarPEG reading positioning)! !

TestCase subclass: #PEGParserPEGTest
	instanceVariableNames: 'parser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xtreams-ParsingTests'!

!PEGParserPEGTest methodsFor: 'initialize-release' stamp: 'nice 1/14/2011 23:20'!
setUp
	parser := PEGParser parserPEG! !

!PEGParserPEGTest methodsFor: 'tests' stamp: 'nice 1/14/2011 23:21'!
testParsePEG
	self assert: (parser parse: 'Grammar' stream: PEGParser grammarPEG reading positioning actor: nil) notEmpty.
	self assert: (parser parse: 'Grammar' stream: PEGParser grammarPEG reading positioning actor: PEGParserParser new) grammar size = 52! !

!PEGParserPEGTest methodsFor: 'tests' stamp: 'nice 1/14/2011 23:21'!
testParsePEGwithPEG
	parser := parser parse: 'Grammar' stream: PEGParser grammarPEG reading positioning actor: PEGParserParser new.
	self testParsePEG! !

!PEGParserPEGTest methodsFor: 'tests' stamp: 'nice 1/14/2011 23:21'!
testValidatePEG
	self assert: (parser validate: 'Grammar' stream: PEGParser grammarPEG reading positioning)! !

TestCase subclass: #PEGParserSmalltalkTest
	instanceVariableNames: 'parser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xtreams-ParsingTests'!

!PEGParserSmalltalkTest methodsFor: 'initialize-release' stamp: 'nice 1/14/2011 23:22'!
setUp
	parser := PEGParser parserPEG parse: 'Grammar' stream: PEGParser grammarSmalltalk actor: PEGParserParser new.! !

!PEGParserSmalltalkTest methodsFor: 'testing' stamp: 'nice 1/14/2011 23:28'!
testBlockExpression

	<timeout: 10 "seconds">
	| expression tree |
	expression := '[super ++ (anInteger - skipped)] on: Incomplete do: [ :ex | ex pass ]'.
	tree := parser parse: 'Expression' stream: expression reading actor: PEGTreeBuilder new.
	tree key value size = expression size! !

!PEGParserSmalltalkTest methodsFor: 'testing' stamp: 'nice 1/14/2011 23:28'!
testExpressionKeywordMessageWithComplexArguments

	<timeout: 10 "seconds">
	| expression tree |
	expression := 'aSequenceableCollection replaceFrom: startIndex to: startIndex + tail - 1 with: cache startingAt: read + 1'.
	tree := parser parse: 'Method' stream: expression reading actor: PEGTreeBuilder new.
	tree key value size = expression size! !

!PEGParserSmalltalkTest methodsFor: 'testing' stamp: 'nice 1/14/2011 23:28'!
testMethodDoubleDashSelector

	<timeout: 10 "seconds">
	| expression tree |
	expression := '-- count	^count'.
	tree := parser parse: 'Method' stream: expression reading actor: PEGTreeBuilder new.
	tree key value size = expression size! !

PEGActor subclass: #PEGTreeBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xtreams-ParsingTests'!

!PEGTreeBuilder methodsFor: 'initialize-release' stamp: 'nice 1/14/2011 23:24'!
process: name object: object start: start stop: stop

	^(name -> (start + 1 to: stop)) -> object! !
